<?php
require_once('./config.php');
header('X-Robots-Tag: noindex');
if(isset($_GET['nyaaid'])) {  /* START NYAAID */
	$nyaaid = $_GET['nyaaid'];
		if ($nyaaid[0] == 's') { $dbdir = 'data_s'; $instance = 'sukebei'; } else { $dbdir = 'data_m'; $instance = 'www'; }
	$nyaaid = preg_replace('[\D]', '', $nyaaid);
	$dbpath = "./$dbdir/".str_pad(floor($nyaaid/1000), 4, "0", STR_PAD_LEFT).".db";
	if (file_exists($dbpath)) { } else { header('Content-Type: application/json'); $response['status'] = "no_such_db"; echo json_encode($response); die; }
	$db = new SQLite3($dbpath);
	$db->busyTimeout($config_db_timeout);
	$result = $db->query("SELECT * FROM nyaainfo WHERE nyaaid='$nyaaid'");
	while ($row = $result->fetchArray()) {
		$tdate = $row['date'];	
		$tbtih = $row['btih'];
		$tcat = $row['category'];
		$tname = $row['name'];
		$tsize = $row['size'];
		$tsub = $row['submitter'];
		$tdesc = $row['description'];
		$tinfo = $row['information'];
		$tseed = $row['seeders'];
		$tleech = $row['leechers'];
		$tdown = $row['downloads'];
		$tcom = $row['comments'];
		$tup = $row['updated'];
	}
	/* check if torrent exists in DB */ if(isset($tdate) and $tdate !== '') { } else { header('Content-Type: application/json'); $response['status'] = "no_such_torrent"; echo json_encode($response); die; }
	if($tup == '') { $tup = "1122334455"; } $actualtime = time(); $lastupdate = $actualtime-$tup; /* to know how long ago was the last update */
	if($lastupdate > "3600") /* [start] updating stats from Nyaa when stats older than 1 hour */
		{
		$torrent_stat_url = "http://$instance.nyaa.eu/?page=torrentinfo&tid=$nyaaid";$torrent_stat_workfile = "./work.html";copy($torrent_stat_url, $torrent_stat_workfile);$content = file_get_contents($torrent_stat_workfile);unlink($torrent_stat_workfile);
		//  status
		if (preg_match("/does not appear to be in our database/i", $content))
		{ /* $subject = 'Requested torrent deleted: '.$_GET['nyaaid']; $body = 'Hi there, request from '.$_SERVER['REMOTE_ADDR'].' ('.gethostbyaddr($_SERVER['REMOTE_ADDR']).') on torrent '.$_GET['nyaaid'].' was valid, but seems like the torrent was removed from Nyaa meanwhile. You can confirm the removing from the Magnyaa engine : '."\n\n".$_SERVER['SERVER_NAME']."/?remove=".$_GET['nyaaid']."&p=$config_admin_password";$headers = 'Content-Type: text/plain; charset=UTF-8'."\n".'From: report@'.$_SERVER['SERVER_NAME']."\n";mail($config_admin_mail, $subject, $body, $headers);*/
		$result = $db->query("DELETE FROM nyaainfo WHERE nyaaid='$nyaaid'");
		}
		else {
			// seeders
			$piece = explode('<td class="vtop">', $content);
			$piece1 = explode('</td>', $piece[2]);
			$tseed = preg_replace('[\D]', '', "$piece1[0]");
			// leechers
			$piece = explode('<td class="vtop">', $content);
			$piece1 = explode('</td>', $piece[3]);
			$tleech = preg_replace('[\D]', '', "$piece1[0]");
			// downloads
			$piece = explode('<td class="vtop">', $content);
			$piece1 = explode('</td>', $piece[4]);
   			$tdown = preg_replace('[\D]', '', "$piece1[0]");
			// description
			$piece = explode('<div class="tinfodescription">', $content);
			$piece1 = explode('</div><h3>', $piece[1]);
			$piece1[0] = str_replace('<img src="', "<br>", $piece1[0]);
			$piece1[0] = str_replace('" alt="Image" />', "<br>", $piece1[0]);
			$piece1[0] = str_replace('<br />', "<br>", $piece1[0]);
			$tdesc = base64_encode("$piece1[0]");
			// information
			$piece = explode('<td class="thead">Information:</td><td>', $content);
			$piece1 = explode('</td>', $piece[1]);
			$tinfo = base64_encode("$piece1[0]");
			// comments
			$piece = explode('<h3>User comments:</h3>', $content);
			$piece1 = explode('<h3>Post a comment:</h3>', $piece[1]);
			$tcom = base64_encode("$piece1[0]");
			//////////////////////////////////////
			$results = $db->exec("UPDATE nyaainfo SET description='$tdesc', information='$tinfo', seeders='$tseed', leechers='$tleech', downloads='$tdown', comments='$tcom', updated='$actualtime' WHERE nyaaid='$nyaaid'");
			//////////////////////////////////////
			}
		}	/* [end] updating stats from Nyaa */
$response['status'] = "ok";
$response['instance'] = $instance;
$response['date'] = $tdate;
$response['btih'] = $tbtih;
$response['category'] = $tcat;
$response['name'] = $tname;
$response['size'] = $tsize;
$response['submitter'] = $tsub;
$response['description'] = $tdesc;
$response['information'] = $tinfo;
$response['seeders'] = $tseed;
$response['leechers'] = $tleech;
$response['downloads'] = $tdown;
$response['comments'] = $tcom;
$response['updated'] = $tup;
	header('Content-Type: application/json');
	echo json_encode($response);
die;
} /* END NYAAID */

/* START TABLE */
if(isset($_GET['db'])) {
	$database = $_GET['db'];
	if(!empty($database)) { if ($database[0] == 's') { $dbdir = 'data_s'; $instance = 'sukebei'; } else { $dbdir = 'data_m'; $instance = 'www'; } } else { $dbdir = 'data_m'; $instance = 'www'; }
	$database = preg_replace('[\D]', '', $database);
	// selecting latest database when not specified
	if($database == '') { $array1 = opendir($dbdir); while (false !== ($array2 = readdir($array1))) {$array3[] = $array2;} natcasesort($array3);$revtable1 = array_reverse($array3); $database = substr($revtable1[0], 0, -3);}
	//  \\
	$dbpath = "./$dbdir/".str_pad($database, 4, "0", STR_PAD_LEFT).".db";
	header('Content-Type: application/json');
	if (file_exists($dbpath)) { } else { $response['status'] = "no_such_db"; echo json_encode($response); die; }
		$db = new SQLite3($dbpath);
		$db->busyTimeout($config_db_timeout);
		$result = $db->query("SELECT * FROM nyaainfo");
		while ($row = $result->fetchArray()) {
			$tid = $row['nyaaid'];
			$tdate = $row['date'];	
			$tbtih = $row['btih'];
			$tcat = $row['category'];
			$tname = $row['name'];
			$tsize = $row['size'];
			$tsub = $row['submitter'];
			$tdesc = $row['description'];
			$tinfo = $row['information'];
			$tseed = $row['seeders'];
			$tleech = $row['leechers'];
			$tdown = $row['downloads'];
			$tcom = $row['comments'];
			$tup = $row['updated'];
		$response['status'] = "ok";
		$response['instance'] = $instance;
		$response['nyaaid'] = $tid;
		$response['date'] = $tdate;
		$response['btih'] = $tbtih;
		$response['category'] = $tcat;
		$response['name'] = $tname;
		$response['size'] = $tsize;
		$response['submitter'] = $tsub;
		$response['description'] = $tdesc;
		$response['information'] = $tinfo;
		$response['seeders'] = $tseed;
		$response['leechers'] = $tleech;
		$response['downloads'] = $tdown;
		$response['comments'] = $tcom;
		$response['updated'] = $tup;
		echo json_encode($response)."\n";
		}
	die;
}

/* END TABLE /

/* START REMOVE */
if (isset($_GET['remove']) && isset($_GET['p']) && $_GET['p'] === $config_admin_password)
{
$nyaaid = $_GET['remove'];
if ($nyaaid[0] == 's') { $dbdir = 'data_s'; } else { $dbdir = 'data_m'; }
$nyaaid = preg_replace('[\D]', '', $nyaaid);
$dbpath = "./$dbdir/".str_pad(floor($nyaaid/1000), 4, "0", STR_PAD_LEFT).".db";
$db = new SQLite3($dbpath);
$db->busyTimeout($config_db_timeout);
$result = $db->query("DELETE FROM nyaainfo WHERE nyaaid='$nyaaid'");
die;
}
/* END REMOVE */
/* START INSERT */
if (isset($_GET['import']) && isset($_GET['p']) && $_GET['p'] === $config_admin_password)
{
$data = base64_decode($_GET['import']);
$csvdata = str_getcsv($data, ",");
if($csvdata[0] == '') { }
	else
		{
		$nyaaid = $csvdata[0];
			if ($nyaaid[0] == 's') { $dbdir = 'data_s'; } else { $dbdir = 'data_m'; }
			$nyaaid = preg_replace('[\D]', '', $nyaaid);
		$tdate = $csvdata[1];	
		$tbtih = $csvdata[2];
		$tcat = $csvdata[3];
		$tname = $csvdata[4];
		$tsize = $csvdata[5];
		$tsub = $csvdata[6];
		$dbpath = "./$dbdir/".str_pad(floor($nyaaid/1000), 4, "0", STR_PAD_LEFT).".db";
		$db = new SQLite3($dbpath);
		$db->busyTimeout($config_db_timeout);
		$result = $db->query("CREATE TABLE IF NOT EXISTS nyaainfo (nyaaid NUMERIC, date INTEGER, btih TEXT, category TEXT, name TEXT, size NUMERIC, submitter TEXT, description TEXT, information TEXT, seeders NUMERIC, leechers NUMERIC, downloads NUMERIC, comments TEXT, updated INTEGER )"); 
		$result = $db->query("DELETE FROM nyaainfo WHERE nyaaid='$nyaaid'");
		$result = $db->query("INSERT INTO nyaainfo (nyaaid, date, btih, category, name, size, submitter) VALUES ('$nyaaid', '$tdate', '$tbtih', '$tcat', '$tname', '$tsize', '$tsub')");
		}
	die;	
}
/* END INSERT */
  /* EXPORT */
if (isset($_GET['export'])) 
{ 
$expire = time()-259200;
$exportfile = "./export.zip";
if (file_exists($exportfile) && filemtime($exportfile) > $expire) { header("Location: $exportfile"); die; }
else
	{
	if (file_exists($exportfile)) { unlink($exportfile); }
	$zip = new ZipArchive;
	if ($zip->open($exportfile, ZIPARCHIVE::CREATE) === TRUE)
		{
		$iterator = new RecursiveIteratorIterator(new RecursiveDirectoryIterator("data_m/"));
		foreach ($iterator as $key=>$value) { $zip->addFile(realpath($key), $key) or die ("ERROR: Could not add file: $key"); }
		$iterator = new RecursiveIteratorIterator(new RecursiveDirectoryIterator("data_s/"));
		foreach ($iterator as $key=>$value) { $zip->addFile(realpath($key), $key) or die ("ERROR: Could not add file: $key"); }
		$zip->close();
		header("Location: $exportfile");die;
		}
	else { echo "error"; }
	}
die;
}    
/* END EXPORT  */
/* LATEST TORRENT IN THE NEWEST DATABASE */
if (isset($_GET['latest'])) 
{
	$array1 = opendir("data_m");
	while (false !== ($array2 = readdir($array1))) {$array3[] = $array2;} natcasesort($array3);$revtable1 = array_reverse($array3);
$lastdbm = $revtable1[0];
$db1 = new SQLite3("data_m/$lastdbm");
$db1->busyTimeout($config_db_timeout);
$result1 = $db1->query("SELECT * FROM nyaainfo ORDER BY nyaaid DESC LIMIT 1");
while ($row1 = $result1->fetchArray()) { $lasttorm = $row1['nyaaid']; }

	$array4 = opendir("data_s");
	while (false !== ($array5 = readdir($array4))) {$array6[] = $array5;} natcasesort($array6);$revtable2 = array_reverse($array6);
$lastdbs = $revtable2[0];
$db2 = new SQLite3("data_s/$lastdbs");
$db2->busyTimeout($config_db_timeout);
$result2 = $db2->query("SELECT * FROM nyaainfo ORDER BY nyaaid DESC LIMIT 1");
while ($row2 = $result2->fetchArray()) { $lasttors = $row2['nyaaid']; }

$response['latest_m'] = $lasttorm;
$response['latest_s'] = $lasttors;
	header('Content-Type: application/json');
	echo json_encode($response);
die;
}
/* END LATEST*/
/* BEGIN EXIST DB */
if (isset($_GET['exist'])) 
{
	$database = $_GET['exist'];
		if ($database[0] == 's') { $dbdir = 'data_s'; } else { $dbdir = 'data_m'; }
	$database = preg_replace('[\D]', '', $database);
	$dbpath = "./$dbdir/".$database.".db";
	if (file_exists($dbpath))
		{
		header('Content-Type: application/json');
		$response['status'] = "ok";
		echo json_encode($response);
		die;
		}
	else
		{
		header('Content-Type: application/json');
		$response['status'] = "no_such_db";
		echo json_encode($response);
		die;
		}

}
/* END EXIST DB */
header('X-Magnyaa: engine1'); die;
?>
